
function [kappa,NRB,M_affine,ARBi,b_RB,Ai,b,fN,N]=RB_offline_all

NBlockx = 2; NBlocky = 2; NPara = 1;
M_affine = 2;
mu_max =  10; kappa = mu_max*ones(1,M_affine);
kappa(1,1) = 1;
% kappa = [1,10]
xmin = 0; xmax = 1; ymin = 0; ymax = 1;
Nlocal = 100;
Nx = NBlockx* Nlocal; Ny = NBlocky*Nlocal;
[node, elem, bdEdge] = get2Dmesh(xmin,xmax,ymin,ymax, Nx, Ny);

N = size(node,1)
NT = size(elem,1)
mu1 = 0.5*ones(1,NPara);
alpha = getTheta(mu1, kappa); %alpha = [1,1]

%get free node
totalEdge = [elem(:,[2,3]); elem(:,[3,1]); elem(:,[1,2])];
isBdEdge = reshape(bdEdge,3*NT,1);
Dirichlet = totalEdge((isBdEdge == 1),:);
fN = 1:N;
isBdNode = false(N,1);
isBdNode(Dirichlet) = true;
bdNode = find(isBdNode);
fN = find(~isBdNode);
sizefN=size(fN,1);

[Ai,A_ref] = getAi(node,elem,M_affine,NBlockx,NBlocky,fN);
b = diffusioneq_b(node,elem,bdEdge,@g_N,fN);

A = sparse(sizefN,sizefN);
for i=1:M_affine
    A = A+alpha(i)*Ai{i};
end
u1 = zeros(N,1);    u1(fN) = A\b;

RB_sol = u1; mu_total = mu1';  error_total = [];

Ntrain = 1000;  trainset = rand(Ntrain,NPara);
eps = 1e-5
M_RB_max = 20

[RB_sol,ARBi,NRB,b_RB,error_total] = ...
    RBGreedy_simple(Ai,M_affine,RB_sol,b,fN,A_ref,Ntrain,...
    trainset,kappa,@getTheta,@geterror,M_RB_max, eps,N,mu_total);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [node, elem, bdEdge] = get2Dmesh(xmin,xmax,ymin,ymax, Nx, Ny)
hx = (xmax-xmin)/Nx;    hy = (ymax-ymin)/Ny;

x = xmin:hx:xmax;
xmid = (x(1:end-1)+x(2:end))/2;
y = ymin:hy:ymax;
ymid = (y(1:end-1)+y(2:end))/2;

Nnode = (Nx+1)*(Ny+1)+Nx*Ny;
node = zeros(Nnode,2);
for i=1:Ny+1
    node((i-1)*(Nx+1)+1 : i*(Nx+1),1) = x';
    node((i-1)*(Nx+1)+1 : i*(Nx+1),2) = y(i);
end
for i=1:Ny
    node((Ny+1)*(Nx+1)+(i-1)*Nx+1 : (Ny+1)*(Nx+1)+i*Nx,1) = xmid';
    node((Ny+1)*(Nx+1)+(i-1)*Nx+1 : (Ny+1)*(Nx+1)+i*Nx,2) = ymid(i);
end

NT = 4*Nx*Ny;
elem = zeros(NT,3);
for i=1:Ny
    xx = (Nx+1)*(Ny+1)+ (i-1)*Nx+1:(Nx+1)*(Ny+1)+ i*Nx;
    elem(4*(i-1)*Nx+1:4:4*(i-1)*Nx+4*(Nx-1)+1,1) = xx';
    elem(4*(i-1)*Nx+2:4:4*(i-1)*Nx+4*(Nx-1)+2,1) = xx';
    elem(4*(i-1)*Nx+3:4:4*(i-1)*Nx+4*(Nx-1)+3,1) = xx';
    elem(4*(i-1)*Nx+4:4:4*(i-1)*Nx+4*(Nx-1)+4,1) = xx';
    
    xx = (i-1)*(Nx+1)+1 : i*(Nx+1)-1;
    elem(4*(i-1)*Nx+1:4:4*(i-1)*Nx+4*(Nx-1)+1,2) = xx';
    elem(4*(i-1)*Nx+1:4:4*(i-1)*Nx+4*(Nx-1)+1,3) = xx'+1;
    
    elem(4*(i-1)*Nx+2:4:4*(i-1)*Nx+4*(Nx-1)+2,2) = xx'+1;
    elem(4*(i-1)*Nx+2:4:4*(i-1)*Nx+4*(Nx-1)+2,3) = xx'+Nx+2;
    
    elem(4*(i-1)*Nx+3:4:4*(i-1)*Nx+4*(Nx-1)+3,2) = xx'+Nx+2;
    elem(4*(i-1)*Nx+3:4:4*(i-1)*Nx+4*(Nx-1)+3,3) = xx'+Nx+1;
    
    elem(4*(i-1)*Nx+4:4:4*(i-1)*Nx+4*(Nx-1)+4,2) = xx'+Nx+1;
    elem(4*(i-1)*Nx+4:4:4*(i-1)*Nx+4*(Nx-1)+4,3) = xx';
end

bdEdge = zeros(NT,3);
% Diri on top
% 0 Neumann on sides
% 1 Neumann on bottom
bdEdge(1:4:4*(Nx-1)+1,1) = 2;
bdEdge(4*Nx*(Ny-1)+3:4:NT-1,1) = 1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function AfN = diffusioneq_A(node,elem,K,fN)
N = size(node,1); NT = size(elem,1); A = sparse(N,N);
%-------- Compute vedge, edge as a vector, and area of each element ------
ve(:,:,1) = node(elem(:,3),:)-node(elem(:,2),:);
ve(:,:,2) = node(elem(:,1),:)-node(elem(:,3),:);
ve(:,:,3) = node(elem(:,2),:)-node(elem(:,1),:);
area = 0.5*abs(-ve(:,1,3).*ve(:,2,2)+ve(:,2,3).*ve(:,1,2));
%-------- Assemble stiffness matrix ---------------------------------------
for i = 1:3
    for j = 1:3
        Aij = K.*(ve(:,1,i).*ve(:,1,j)+ve(:,2,i).*ve(:,2,j))./(4*area);
        A = A + sparse(elem(:,i),elem(:,j),Aij,N,N);
    end
end

AfN=A(fN,fN);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function bfN = diffusioneq_b(node,elem,bdEdge,g_N,fN)
N = size(node,1); NT = size(elem,1); b = zeros(N,1);
%-------- Boundary edges ----------------------------------------------
totalEdge = [elem(:,[2,3]); elem(:,[3,1]); elem(:,[1,2])];
isBdEdge = reshape(bdEdge,3*NT,1);
Neumann = totalEdge((isBdEdge == 2),:);

%-------------------- Neumann boundary conditions -------------------------
if (~isempty(Neumann) && ~isempty(g_N))
    Nve = node(Neumann(:,1),:) - node(Neumann(:,2),:);
    edgeLength = sqrt(sum(Nve.^2,2));
    mid = (node(Neumann(:,1),:) + node(Neumann(:,2),:))/2;
    b = b + accumarray([Neumann(:),ones(2*size(Neumann,1),1)], ...
        repmat(edgeLength.*g_N(mid)/2,2,1),[N,1]);
end
bfN = b(fN,1);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function z = g_N(p) % Neumann boundary condition
z = ones(size(p,1),1);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [Ai,A_ref] = getAi(node,elem,M_affine,NBlockx,NBlocky,fN)

Ai = cell(1,M_affine);
A_i = cell(1,NBlockx*NBlocky);
NT = size(elem,1);

center = (node(elem(:,1),:)+node(elem(:,2),:)+node(elem(:,3),:))/3;
x = center(:,1);    y = center(:,2);
K  = ones(size(center,1),1);
ix = zeros(size(center,1),NBlockx*NBlocky);
for i=1:NBlockx
    for j =1:NBlocky
        ix(:,(i-1)*NBlocky+j) = ...
            ((i-1)/NBlockx<x).*(x<i/NBlockx).*((j-1)/NBlocky<y).*(y<j/NBlocky);
    end
end

for i=1:NBlockx*NBlocky
    K  = zeros(NT,1); K(logical(ix(:,i))) = 1;
    A_i{i} = diffusioneq_A(node,elem,K,fN);
end
Ai{1} = A_i{1} + A_i{4};
Ai{2} = A_i{2} + A_i{3};

sizefN = size(fN,1);
A_ref = sparse(sizefN,sizefN);
for i=1:M_affine
    A_ref = A_ref +Ai{i};
end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ARBi, b_RB,h_N,G] = ...
    getARB(Ai,NRB, M_affine,RB_sol,b,fN,h_N,A_ref,ARBi_old,b_RB_old)

ARBi = cell(1,M_affine);
for i = 1:M_affine
    ARBi{i} = zeros(NRB,NRB);
end

if (NRB>1)
    for i_affine=1:M_affine
        ARBi{i_affine}(1:NRB-1,1:NRB-1) = ARBi_old{i_affine};
    end
end

for i_affine=1:M_affine
    for j = 1:NRB
        ARBi{i_affine}(NRB,j) = RB_sol(fN,NRB)'*Ai{i_affine}*RB_sol(fN,j);
        ARBi{i_affine}(j,NRB) = RB_sol(fN,j)'*Ai{i_affine}*RB_sol(fN,NRB);
    end
end

b_RB = zeros(NRB,1);
if (NRB>1)
    b_RB(1:NRB-1,1) = b_RB_old;
end
b_RB(NRB,1) = dot(RB_sol(fN,NRB),b);
for i = 1:M_affine
    h_N = [h_N, -Ai{i}*RB_sol(fN,NRB)];
end
G = h_N'/A_ref*h_N;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function alpha = getTheta(mu, kappa)
mu = [0.5, mu];
alpha = kappa.^(2*mu-1);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function u_RB = getu_RB(alpha,NRB,M_affine,ARBi,b_RB)

ARB = zeros(NRB,NRB);
for i=1:M_affine
    ARB = ARB + alpha(i)*ARBi{i};
end
u_RB = ARB\b_RB;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function error = geterror(alpha,M_affine,NRB,G,u_RB)

E_N_mu = zeros(1,1+M_affine*NRB);
E_N_mu(1) =1;
for i_e = 1:NRB
    for j_e=1:M_affine
        E_N_mu(1+(i_e-1)*M_affine+j_e) = alpha(j_e)*u_RB(i_e);
    end
end
alpha_LB = min(alpha);
error = sqrt(abs(E_N_mu*G*E_N_mu'))/abs(alpha_LB);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function u_add_gs = getu_add(alpha,Ai,N,NRB,M_affine,fN,b,A_ref,RB_sol)

sizefN = size(fN,1);
A = sparse(sizefN,sizefN);
for i=1:M_affine
    A = A+alpha(i)*Ai{i};
end
u_add = zeros(N,1);
u_add(fN) = A\b;
u_add_gs = u_add;
for i = 1:NRB
    a_i =(RB_sol(fN,i)'*A_ref*u_add(fN))...
        /(RB_sol(fN,i)'*A_ref*RB_sol(fN,i));
    % can be further simplified by saving RB_sol(fN,i)'*A_ref*RB_sol(fN,i)
    u_add_gs(fN) = u_add_gs(fN) - a_i*RB_sol(fN,i);
end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [RB_sol, ARBi, NRB,b_RB,error_total] = ...
    RBGreedy_simple(Ai,M_affine,RB_sol,b,fN,A_ref,Ntrain,...
    trainset,kappa,getTheta,geterror,M_RB_max, eps,N,mu_total)

NRB = 0; error0 = 2; error_total = []; h_N = [b];

while ( (NRB < M_RB_max) && (error0 > eps) )
    NRB = NRB+1
    if NRB > 1
        [ARBi, b_RB,h_N,G] = ...
          getARB(Ai,NRB, M_affine,RB_sol,b,fN,h_N,A_ref,ARBi_old,b_RB_old);
    else
       [ARBi, b_RB,h_N,G] = getARB(Ai,NRB, M_affine,RB_sol,b,fN,h_N,A_ref);
    end
    
    error0=0;    
    for k1 = 1:Ntrain
        mu = trainset(k1,:);
        alpha = getTheta(mu, kappa);
        u_RB = getu_RB(alpha,NRB,M_affine,ARBi,b_RB);
        error = geterror(alpha,M_affine,NRB,G,u_RB);
        if (error > error0)
            mu_add = mu; error0 = error; maxpos = k1;
        end
    end
    error0
    if (error0 > eps)
        alpha = getTheta(mu_add, kappa);
        u_add_gs = getu_add(alpha,Ai,N,NRB,M_affine,fN,b,A_ref,RB_sol);        
        RB_sol = [RB_sol,u_add_gs]; mu_total = [mu_total,mu_add'];
        error_total = [error_total,error0];        
        for i =1:M_affine
            ARBi_old{i} = zeros(NRB,NRB);
            ARBi_old{i} = ARBi{i};
        end
        b_RB_old = b_RB;
    end
end
end
